#include <avr/io.h>
#include "mLCD/mLCD.h"
#include "lcd.h"

static uint8_t backLight_status = 0;

/*****************************************************************************
*							LCDW[
* Fuint8_t sw ON / OFF  ̃obNCg
* ߒlFvoid
*****************************************************************************/
void lcdInit( uint8_t sw )
{
	mLCD_init();
	mLCD_brtnes( 16 );
}

/*****************************************************************************
*								obNCgԎ擾
* Fvoid
* ߒlFuint8_t ON/OFF
*****************************************************************************/
uint8_t lcdBackLightStatus( void )
{
	return ( backLight_status );
}

/*****************************************************************************
*								obNCg
* Fuint8_t sw ON / OFF
* ߒlFvoid
*****************************************************************************/
void lcdBackLight( uint8_t sw )
{
	;
}

/*****************************************************************************
*								ʃNA
* Fvoid
* ߒlFvoid
*****************************************************************************/
void lcdCls( void )
{
	mLCD_clear();
}

/*****************************************************************************
*							J[\^CvύX
* FLCD_CURSOL_TYPE type J[\^Cv
*							 LCD_CURSOL_OFF      : J[\\
*							 LCD_CURCOL_BLINK    : ubN_
*							 LCD_CURSOL_UNDERBAR : A_[o[
* ߒlFvoid
*****************************************************************************/
void lcdCursol( LCD_CURSOL_TYPE type )
{
	mLCD_cmd( 0x0c | ( type & 0x03 ) );
}

/*****************************************************************************
*								J[\ړ
* Fuint8_t row		sԍ(0`)
*		uint8_t column	ԍ(0`)
* ߒlFvoid
*****************************************************************************/
void lcdLocate( uint8_t row ,uint8_t column )
{
	mLCD_gopos( row ,column );
}

/*****************************************************************************
*								Po
* Fchar c         R[h
* ߒlFvoid
*****************************************************************************/
void lcdPutc( char c )
{
	mLCD_put( c );
}

/*****************************************************************************
*						RAM̈̕o
*	Fchar *s  
*	ߒlF
*****************************************************************************/
void lcdPuts( char *s )
{
	while ( *s ) {
		mLCD_put( *s++ );
	}
}

/*****************************************************************************
*						R[ḧ̕o
*	Fconst char *s 
*	ߒlFvoid
*
*	ex. lcdPuts_P( PSTR( "Test!!" ) );
*****************************************************************************/
void lcdPuts_P( const char *s ) 
{
	char c;
	while ( ( c = pgm_read_byte( s++ ) ) ) {
		mLCD_put( c );
	}
}
