/*############################################################################
#  USB d                                                                #
#                                                                            #
#@RpCmFFAtmelStudio 6.1.2730(SP2)                             #
#                                                                            #
#                                                  2014/02/08 Create by nPYO #
############################################################################*/
#define __MAIN_C__
#include "project.h"

#define BACK_LIGHT_DEFAULT 40			/* LCDobNCg_			*/

/* [J֐vg^Cv錾		*/
static uint8_t usbPowerProcess( void );
static void dispInfo( void );
static void hardwareInit( void );

/*****************************************************************************
*  荞݃xN^
*							A/DϊI
*****************************************************************************/
ISR( ADC_vect )
{
	/* Ȃ(X[vpj	*/
}

/*****************************************************************************
*  荞݃xN^
*						^C}[0 rv
*****************************************************************************/
ISR( TIMER0_COMPA_vect )
{
	/* Ȃ(X[vpj	*/
}

/*****************************************************************************
*							   USBdC
* Fvoid
* ߒlFuint8_t 0:Xe[^XωȂ  !0:Xe[^XωL
*****************************************************************************/
static uint8_t usbPowerProcess( void )
{
	static uint8_t blinkCount[ USB_N ] = { 0 ,0 };
	uint8_t ret = 0;

	/* dǗ							*/
	for ( uint8_t i = 0 ;i < USB_N ;i++ ) {
		measurement_usb_port( i );

		if ( sys.USB_mode[ i ] == MODE_STANDBY ) {			/* X^oCH				*/
			if ( ( sys.USB_current[ i ] >= 2U ) &&			/* ׂoH(2mAȏ)		*/
			     ( sys.USB_voltage[ i ] < 4800U ) ) {		/* d~LH				*/
				dcdc_enable( i );							/* DC/DCo͊Jn				*/
				sys.USB_mode[ i ] = MODE_ENABLE;			/* d֑J					*/
				ret = 1;
			}

		} else if ( sys.USB_mode[ i ] == MODE_ENABLE ) {	/* dH						*/

			if ( sys.USB_current[ i ] < 2U ) {				/* זڑH(2mA)		*/
				dcdc_disable( i );							/* DC/DCo͒~				*/
				led_set_mode( i ,LED_OFF );
				sys.USB_mode[ i ] = MODE_STANDBY;			/* X^oC֑J				*/
				ret = 2;

			} else if ( sys.USB_current[ i ] >= 3100U ) {	/* ߕׂoH(3.10Aȏ)	*/
				dcdc_disable( i );							/* DC/DCo͒~				*/
				led_set_mode( i ,LED_ON );					/* LED_						*/
				sys.USB_mode[ i ] = MODE_OVERLOAD;			/* ߕ׏Ԃ֑J				*/
				ret = 3;

			} else if ( ++blinkCount[ i ] >= 5 ) {			/* dlxv_			*/
				blinkCount[ i ] = 0;
				if ( sys.USB_current[ i ] >= eep.usb_CurrentWarning[ i ] ) {
					led_set_mode( i ,( led_get_mode( i ) == LED_OFF ) ? LED_ON : LED_OFF );
				} else {
					led_set_mode( i ,LED_OFF );
				}
			}

		} else if ( sys.USB_mode[ i ] == MODE_OVERLOAD ) {	/* ߕ׏ԒH				*/
			if ( sw_status( i ) == SW_ON ) {				/* AXCb`H			*/
				if ( sys.USB_current[ i ] <= 3U ) {			/* זڑH(3mAȉ)		*/
					led_set_mode( i ,LED_OFF );
					sys.USB_mode[ i ] = MODE_STANDBY;
					ret = 4;
				}
			}

		} else {											/* s̃G[H			*/
			;

		}
	}

	return ( ret );
}

/*****************************************************************************
*							   USBdXe[^X\
* Fvoid
* ߒlFvoid
*****************************************************************************/
static void dispInfo( void )
{
	char buf[ 18 ];

	for ( uint8_t i = 0 ;i < USB_N ;i++ ) {

		sprintf_P( buf ,PSTR("[%c]             ") ,'A' + i );

		if ( sys.USB_mode[ i ] == MODE_STANDBY ) {				/* X^oCH						*/
			strcpy_P( &buf[4] ,PSTR("ready.      ") );

		} else if ( sys.USB_mode[ i ] == MODE_ENABLE ) {		/* dH							*/
			uint16_t e = shift_right( sys.USB_voltage[ i ] ,1 );/* 0.01VPʂɊۂ߂				*/
			uint16_t c = sys.USB_current[ i ];
			if ( sys.USB_current_vref[ i ] == 1 ) {				/* t@Xd AVCC?			*/
				c = shift_right( c ,1 );						/* 0.01APʂɊۂ߂				*/
				sprintf_P( &buf[4] ,PSTR("%u.%02uV %2u.%02uA") ,e / 100U ,e % 100U ,c / 100U ,c % 100U );
			} else {
				sprintf_P( &buf[4] ,PSTR("%u.%02uV %4umA") ,e / 100U ,e % 100U ,c );
			}

		} else if ( sys.USB_mode[ i ] == MODE_OVERLOAD ) {		/* ߕהH						*/
			strcpy_P( &buf[4] ,PSTR("overload !! ") );

		} else {
			strcpy_P( &buf[4] ,PSTR("? unknown.  ") );			/* sȏԁH						*/

		}

		/* LCD\			*/
		lcdLocate( i ,0 );
		lcdPuts( buf );
	}
}

/*****************************************************************************
*								n[hEGA
* Fvoid
* ߒlFvoid
*****************************************************************************/
static void hardwareInit( void )
{
	wdt_disable();		/* ZbgÕEIb`hbN^C}[ݒ𖳌ɂ	*/

	/*  PortB +--------7: Pullup : N.C.                                         */
	/*        |+-------6: Pullup : #SW-A                                        */
	/*        ||+------5: Out(H) : SPI-SCK                                      */
	/*        |||+-----4: HI-Z   : SPI-MISO                                     */
	/*        ||||+----3: Out(H) : SPI-MOSI                                     */
	/*        |||||+---2: Out(L) : #SW-B                                        */
	/*        ||||||+--1: Out(L) : DC/DC2 Enable                                */
	/*        |||||||+-0: Out(L) : DC/DC1 Enable                                */
	DDRB  = 0b00101011;
	PORTB = 0b11101100;

	/*  PortC +--------7: ------ :                                              */
	/*        |+-------6: ------ :                                              */
	/*        ||+------5: Out(L) : LCD-E                                        */
	/*        |||+-----4: Out(L) : LCD-RW                                       */
	/*        ||||+----3: HI-Z   : DC/DC2 (V)                                   */
	/*        |||||+---2: HI-Z   : DC/DC2 (A)                                   */
	/*        ||||||+--1: HI-Z   : DC/DC1 (A)                                   */
	/*        |||||||+-0: HI-Z   : DC/DC1 (V)                                   */
	DDRC  = 0b00110000;
	PORTC = 0b00000000;

	/*  PortD +--------7: Out(H) : #LED-B                                       */
	/*        |+-------6: Out(L) : LCD-BackLight                                */
	/*        ||+------5: Out(H) : #LED-A                                       */
	/*        |||+-----4: Out(L) : LCD-RS                                       */
	/*        ||||+----3: Out(L) : LCD-DB7                                      */
	/*        |||||+---2: Out(L) : LCD-DB6                                      */
	/*        ||||||+--1: Out(L) : LCD-DB5                                      */
	/*        |||||||+-0: Out(L) : LCD-DB4                                      */
	DDRD  = 0b11111111;
	PORTD = 0b00000000;

	/* AiORp[^			*/
	ACSR = _BV(ACD);

	/* ȓd͐ݒ(gȂ@\OFFj	*/
	PRR = _BV(PRTWI) | _BV(PRTIM2) | _BV(PRTIM1) | _BV(PRSPI) | _BV(PRUSART0);

	/* ^C}[0(8bit)ݒ				*/
	TCCR0A = _BV(WGM01);							/* CTC 샂[h					*/
	TCCR0B = _BV(CS02) | _BV(CS00);					/* 1MHz/1024=976.5625Hz			*/
	TCNT0 = 0;
	TIMSK0 |= _BV(OCIE0A);							/* ^C}[0 rvݗL		*/

	/* EIb`hbN^C}[ݒ		*/
	wdt_enable( WDTO_1S );

	/* X[v						*/
	sleep_enable();

	/* O[oC^vgL		*/
	sei();

	/* ADCݒ							*/
	adc_init();

	/* LCD						*/
	lcdInit( OFF );
}

/*****************************************************************************
*									C֐
* Fvoid
* ߒlFint ---
*****************************************************************************/
int main( void )
{
	/* eytF						*/
	hardwareInit();

	/* ̃XCb`ԂŋNH		*/
	uint8_t sw = ( ( sw_status( USB_A ) == SW_ON ) && ( sw_status( USB_B ) == SW_ON ) ) ? 1 : 0;

	/* VXeϐ						*/
	for ( uint8_t i = 0 ;i < USB_N ;i++ ) {
		sys.OPAMP_offset[ i ] = 0UL;
		sys.USB_current[ i ] = 9999U;
		sys.USB_voltage[ i ] = 9999U;
		sys.vbus_offset[ i ] = 0L;
	}

	/* EEPϐǂݍ							*/
	if ( load_eep() ) {										/* G[H		*/

		/* EEPϐftHglݒ				*/
		eep.avcc = (uint32_t)( AVCC * 1000000.0 );
		eep.vref = (uint32_t)( IN_VREF * 1000000.0 );

		eep.usb_CurrentWarning[ USB_A ] = 2500U;
		eep.usb_CurrentWarning[ USB_B ] = 2500U;

		eep.usb_vbus[ USB_A ] = (uint32_t)( VBUS_A * 1000000.0 );
		eep.vadj[ USB_A ] = (uint32_t)( V_ADJ_A * 10.0 );

		eep.usb_vbus[ USB_B ] = (uint32_t)( VBUS_A * 1000000.0 );
		eep.vadj[ USB_B ] = (uint32_t)( V_ADJ_A * 10.0 );

		sw = 1;			/* VXep[^ݒʌďom	*/
	}

	/* S|[gב҂						*/
	wait_no_load();

	/* eItZbgl						*/
	measurement_offsets();

	/* VXeݒʌďo					*/
	if ( sw ) {
		system_setup();
		cpu_reset();
		while ( 1 );
	}

	/* IyAvItZbgl\				*/
	for ( uint8_t i = 0 ;i < USB_N ;i++ ) {
		char buf[ 18 ];
		sprintf_P( buf ,PSTR("%c] Offset %4lumV") ,'A' + i ,shift_right32( sys.OPAMP_offset[ i ] ,3 ) );
		lcdLocate( i ,0 );
		lcdPuts( buf );
	}

	lcdBackLight( ON );
	WAIT_MS( 1000 );

	/* C[v								*/
	uint8_t back_light_count = BACK_LIGHT_DEFAULT;
	while ( 1 ) {

		/* EIb`hbNZbg				*/
		wdt_reset();

		/* USBd							*/
		if ( usbPowerProcess() ) {
			back_light_count = BACK_LIGHT_DEFAULT;
		}

		/* obNCg^C}[				*/
		if ( back_light_count ) {

			/* Xe[^X\					*/
			if ( ( back_light_count == BACK_LIGHT_DEFAULT ) || ( ( back_light_count % 5 ) == 0 ) ) {
				dispInfo();
				lcdBackLight( ON );
			}

			/* dƉߕ׎̓obNCgȂ	*/
			if ( !--back_light_count ) {
				for ( uint8_t i = 0 ;i < USB_N ;i++ ) {
					if ( ( sys.USB_mode[ i ] == MODE_ENABLE ) || ( sys.USB_mode[ i ] == MODE_OVERLOAD ) ) {
						back_light_count = BACK_LIGHT_DEFAULT;
						break;
					}
				}
			}

			if ( !back_light_count ) lcdBackLight( OFF );
		}

		/* w莞CPUX[v					*/
		cpu_sleep( SLEEP_10MS );
    }

	return ( 0 );
}
