#define __MEASUREMENT_C__
#include "project.h"

#define WAIT_DEFAULT_TIME 10				/* VREF؂ւ̑ҋ@(ms)	*/

/* ADC`le[u		*/
static const uint8_t chSP[ USB_N ] PROGMEM = { ADC_VBUS_A ,ADC_VBUS_B };
static const uint8_t chSH[ USB_N ] PROGMEM = { ADC_GND_A  ,ADC_GND_B  };

/* [Jϐ`				*/
static uint8_t lastMode = 0xff;				/* Oɐݒ肵Vrefl				*/

/*****************************************************************************
*									ADC
* Fvoid
* ߒlFvoid
*****************************************************************************/
void adc_init( void )
{
	DIDR0 = _BV(3) | _BV(2) | _BV(1) | _BV(0);	/* PC0`3 : fW^͋֎~	*/

	ADCSRA = _BV(ADEN)							/* ADCL					*/
	       | _BV(ADIE)							/* 荞݋					*/
		   | ADC_FDIV2;							/* 1MHz/2=500kHz			*/
	adc_select_vref( 3 );						/* t@Xd=AVCC		*/
}

/*****************************************************************************
*									A/Dϊs
* Fuint8_t ch 擾`l
* ߒlFuint16_t   ADCJEgl
*****************************************************************************/
uint16_t adc_execution( uint8_t ch )
{
	if ( ( ADMUX & 0x0f ) != ch ) {		/* `lݒ					*/
		uint8_t reg = ADMUX & 0xe0;
		ADMUX = reg | ( ch & 0x0f );
	}

	set_sleep_mode( SLEEP_MODE_ADC );	/* CPUX[v[hFADCGጸ	*/
	ADCSRA |= _BV( ADSC );				/* A/DϊJn						*/
	sleep_cpu();						/* A/Dϊ܂CPUX[v		*/

	return ( ADC );
}

/*****************************************************************************
*								ADCdݒ
* Fuint8_t mode 0 : Od
*					 1 : AVCC
*					 2 : ---
*					 3 : d(1.1V)
* ߒlFvoid
* 
*****************************************************************************/
void adc_select_vref( uint8_t mode )
{
	uint8_t reg = ADMUX & 0x0f;
	ADMUX = ( ( mode & 0x03 ) << REFS0 ) | reg;
	WAIT_MS( WAIT_DEFAULT_TIME );			/* 肷܂ł̈Sԑ҂	*/
	adc_execution( ADMUX & 0x0f );			/* Ô߃_~[A/Dϊ		*/
	lastMode = mode;
}

/*****************************************************************************
*							A/Dϊdl擾iWj
* Fuint8_t  ch     `lԍ
* ߒlFuint32_t        A/DϊdliVj
*****************************************************************************/
uint32_t adc_get_value( uint8_t ch )
{
	uint16_t ad;
	uint32_t vref = 0UL;

	/* t@Xd1.1VőiS񑪒̕ϒlj	*/
	adc_select_vref( 3 );
	ad = 0;
	for ( uint8_t i = 4 ;i ;i-- ) ad += adc_execution( ch );
	ad /= 4;

	if ( ad < ( (uint16_t)ADC_RESOLUTION - 1U ) ) {
		vref = eep.vref;

	/* I[o[t[̏ꍇ̓t@XdAVCC(5.0V)ōđ	*/
	} else {
		adc_select_vref( 1 );
		ad = 0;
		for ( uint8_t i = 4 ;i ;i-- ) ad += adc_execution( ch );
		ad /= 4;
		vref = eep.avcc;
	}

	/* JEgldlɕϊ							*/
	return ( ( vref * (uint32_t)ad )  / (uint32_t)ADC_RESOLUTION );
}

/****************************************************************************
*						wUSB|[gVBUS-GNDd
* Fuint8_t  port USB_A / USB_B
* ߒlFuint32_t o͓d(V)
*****************************************************************************/
uint32_t measurement_vbus_gnd( uint8_t port )
{
	/* R̒_d擾(V)		*/
	uint32_t vCenter = adc_get_value( pgm_read_byte( &chSP[ port ] ) );

	/* dl(mA) = vCenter / R2		*/
	uint32_t iSP = ( vCenter * 100UL ) / (uint32_t)VBUS_R2;

	/* VBUS-GNDԓd(V) = ( R1 + R2 ) * iSP	*/
	uint32_t vSP = iSP * ( (uint32_t)VBUS_R1 + (uint32_t)VBUS_R2 ) / 100UL;

	return ( vSP );
}

/*****************************************************************************
*					wUSB|[g̓dEd𑪒
* Fuint8_t port	USB_A / USB_B
* ߒlFvoid
*	ʂ̓VXeϐɓ
*		sys.USB_voltage[]      , sys.USB_current[]
*		sys.USB_voltage_vref[] ,sys.USB_current_vref[]
*****************************************************************************/
void measurement_usb_port( uint8_t port )
{
	/*									*/
	/* d							*/
	/*									*/

	/* IyAv̏o͓d擾(V)	*/
	uint32_t vOP = adc_get_value( pgm_read_byte( &chSH[ port ] ) );
	uint8_t iRef = lastMode;

	/* IyAv̏o̓ItZbg	*/
	if ( vOP >= sys.OPAMP_offset[ port ] ) {
		vOP -= sys.OPAMP_offset[ port ];
	} else {
		vOP = 0UL;
	}

	/* VgRd(V) = IyAvo͓d	*/
	const uint32_t a = (uint32_t)( ( ( OPAMP_R1 + OPAMP_RF ) / OPAMP_R1 ) * 1000.0 );
	uint32_t vSH = ( vOP * 1000UL ) / a;

	/* VgRɗdvZ(100AP)				*/
	uint32_t iSH = vSH / (uint32_t)( SHUNT_R * 100.0 );

	/* mAPʂ̎Ɋۂ߂				*/
	iSH += 5UL;
	iSH /= 10UL;
	if ( iSH >= 9999UL ) {
		iSH = 9999UL;
	}

	/*									*/
	/* VBUSd						*/
	/*									*/
	uint32_t vSP = measurement_vbus_gnd( port );			/* VBUS - GNDd擾(V)	*/
	uint8_t vRef = lastMode;
	
	if ( sys.vbus_offset[ port ] > 0L ) {					/* ItZbg␳			*/
		vSP += (uint32_t)sys.vbus_offset[ port ];			
	} else if ( sys.vbus_offset[ port ] < 0L ) {
		vSP -= (uint32_t)( -1L * sys.vbus_offset[ port ] );
	}

	/* VgR̓d~덷␳	*/
	vSH *= eep.vadj[ port ];
	vSH /= 10UL;

	/* VgR̓d~		*/
	uint32_t vVBUS = 0UL;
	if ( vSP > vSH ) vVBUS = vSP - vSH;

	/* mVPʂ̎Ɋۂ߂				*/
	vVBUS = ( vVBUS + 500UL ) / 1000UL;
	if ( vVBUS >= 9999UL ) {
		vVBUS = 9999UL;
	}

	/* VXeϐXV					*/
	sys.USB_current_vref[ port ] = iRef;
	sys.USB_current[ port ] = (uint16_t)iSH;

	sys.USB_voltage_vref[ port ] = vRef;
	sys.USB_voltage[ port ] = (uint16_t)vVBUS;
}

/*****************************************************************************
*							   eItZbgl
* Fvoid
* ߒlFvoid
*****************************************************************************/
void measurement_offsets( void )
{
	dcdc_enable_all();
	WAIT_MS( 200 );

	for ( uint8_t i = 0 ;i < USB_N ;i++ ) {
		sys.OPAMP_offset[ i ] = adc_get_value( pgm_read_byte( &chSH[ i ] ) );	/* OPAvo̓ItZbgl	*/

		uint32_t vbus = measurement_vbus_gnd( i );								/* VBUSRItZbgl	*/
		if ( eep.usb_vbus[ i ] >= vbus ) {
			sys.vbus_offset[ i ] = (long)( eep.usb_vbus[ i ] - vbus );
		} else {
			sys.vbus_offset[ i ] = (long)( vbus - eep.usb_vbus[ i ] ) * -1L;
		}
	}

	dcdc_disable_all();
}

/*****************************************************************************
*								S|[gב҂
* Fvoid
* ߒlFvoid
*****************************************************************************/
void wait_no_load( void )
{
	uint8_t tick = LED_OFF;
	uint8_t flg = 0;

	dcdc_disable_all();
	do {
		wdt_reset();
		flg = 0;
		for ( uint8_t i = 0 ;i < USB_N ;i++ ) {
			uint32_t v = measurement_vbus_gnd( i );		/* VBUSd擾		*/
			if ( v < 4800000LU ) {						/* 4.80VH		*/
				led_set_mode( i ,tick );				/* LED_			*/
				flg = 1;
			} else {
				led_set_mode( i ,LED_OFF );				/* LED			*/
			}
		}
		tick ^= 1;
		cpu_sleep( SLEEP_150MS );
	} while ( flg );
}
