/*############################################################################
#                                                                            #
#             LN^[LCDuSC1602BS-BvphCo                        #
#                                                                            #
#@RpCmFFAtmelStudio 6.1(SP2)                                  #
#                                                                            #
#                                                  2012/11/17 Create by nPYO #
#                                                  2014/01/11 Update by nPYO #
#@mFW[F                                                      #
#@@Hʏ uSC1602BS-BvobNCg(16x2s)                       #
#@@Hʏ uSC1602BBWB-XA-GB-GvobNCgt(16x2s)             #
#                                                                            #
#@F                                                                    #
#    f[^p|[g͔Cӂ̃|[g̉4rbgĉ\                   #
#    |[g͔CӃ|[g̔CӃrbgĉ\                          #
#@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@#
#	 RWM𐧌䂵Ȃꍇ́A6{̐Ő\BusymFȗ #
#@@ɗ]ȃEGCg}ׁAXx]ƂȂB				 #
#                                                                            #
#    RWM𐧌䂷ꍇALCDBusymF铮sAȂ炩̗R   #
#    ɂALCDȂȂƖ[vɂȂ\B             #
#    ׁ̈AEIb`hbN^C}[𕹗p邱Ƃ]܂B				 #
#                                                                            #
#    DB0`DB3̓I[vŎgp邱ƁB										 #
#    HD44780̃f[^V[głEȊO̓vAbvĂB                #
#    GNDɐڑĂ܂ƁAd͂΂łȂA8bit[h     #
#    炩̗RőJڂɏo̓[hɂȂĂƃV[g댯L  #
#                                                                            #
#    d𒼐AVR|[g邱Ƃ\B(d Max 6mA)               #
#                                                                            #
#    ڑj DB4   ---  PC0                                                 #
#             DB5   ---  PC1                                                 #
#             DB6   ---  PC2                                                 #
#             DB7   ---  PC3                                                 #
#             RS    ---  PC4                                                 #
#             E     ---  PC5 --- 10KxPulldownقǂ			 #
#             R/W   ---  PD2 --- gpȂꍇGNDɐڒn邱           #
#             VDD   ---  PD3 --- ڃ|[gd͂\(ő6mA)     #
#                                                                            #
#     obNCgLEDgp̗i|[gdłgWX^  #
#                                hCu@ǂƎvBj        #
#             A     ---  15mA(CRD) --- VCC                                   #
#             K     ---  NPN-tr(C) 2SC1815̃gWX^̃RN^Ɛڑ   #
#             Tr(B) -+-  10K --- PD6 Hiɂ_                            #
#                    |                                                       #
#                    +-  100K -- GND (v_E)                            #
#             Tr(E) ---  GND                                                 #
#                                                                            #
############################################################################*/
#define __LCD_C__

#include <avr/io.h>
#include <util/delay.h>
#include <avr/wdt.h>
#include "lcd.h"

/* ef[^WX^`				*/
#define RS_DDR  ( *(volatile uint8_t *)( &RS_PIN + 0x01 ) )
#define RS_PORT ( *(volatile uint8_t *)( &RS_PIN + 0x02 ) )

#define E_DDR  ( *(volatile uint8_t *)( &E_PIN + 0x01 ) )
#define E_PORT ( *(volatile uint8_t *)( &E_PIN + 0x02 ) )

#define DATA_DDR  ( *(volatile uint8_t *)( &DATA_PIN + 0x01 ) )
#define DATA_PORT ( *(volatile uint8_t *)( &DATA_PIN + 0x02 ) )

#if USE_RW
#define RW_DDR  ( *(volatile uint8_t *)( &RW_PIN + 0x01 ) )
#define RW_PORT ( *(volatile uint8_t *)( &RW_PIN + 0x02 ) )
#endif

#if USE_POWER
#define POWER_DDR  ( *(volatile uint8_t *)( &POWER_PIN + 0x01 ) )
#define POWER_PORT ( *(volatile uint8_t *)( &POWER_PIN + 0x02 ) )
#endif

#if USE_BACKLIGHT
#define BACKLIGHT_DDR  ( *(volatile uint8_t *)( &BACKLIGHT_PIN + 0x01 ) )
#define BACKLIGHT_PORT ( *(volatile uint8_t *)( &BACKLIGHT_PIN + 0x02 ) )
#endif

/* RS|[gݒ}N`			*/
#define RS_INSTRUCTIONCODE()	{ RS_PORT &= ~_BV( RS_BIT ); }
#define RS_DATACODE()			{ RS_PORT |=  _BV( RS_BIT ); }

/* E|[gݒ}N`			*/
#define E_ENABLE()				{ E_PORT |=  _BV( E_BIT ); }
#define E_DISABLE()				{ E_PORT &= ~_BV( E_BIT ); }

/* R/W|[gݒ}N`			*/
#if USE_RW
#define RW_READ()				{ RW_PORT |=  _BV( RW_BIT ); }
#define RW_WRITE()				{ RW_PORT &= ~_BV( RW_BIT ); }
#else
#define RW_READ()
#define RW_WRITE()
#endif

/* f[^|[gݒ}N`		*/
#if USE_RW
#define PORT_MODE_IN()			{ DATA_DDR &= 0xf0; DATA_PORT &= 0xf0; }
#define PORT_MODE_OUT()			{ DATA_DDR |= 0x0f; }
#else
#define PORT_MODE_IN()
#define PORT_MODE_OUT()
#endif

/* R/W|[ggp̃EGCg萔	*/
#if !USE_RW
#define NORMAL_COMMAND_TIME     1.00	/* ʏR}h̑Ҏ(msec)		*/
#define CLS_COMMAND_TIME        4.00	/* CLSR}h̑Ҏ(msec)		*/
#endif									/* CLSs̑҂ԂNORMAL_COMMAND_TIMECLS_COMMAND_TIME̍vԂƂȂ	*/

/* Xg[upX҂Ԓ萔		*/
#define E_WAIT_TIME				0.25	/* secP(250nsec)				*/

/* f[^[hύX҂		*/
#define RS_WAIT_TIME			0.10	/* secP(100nsec)				*/

/*	[J֐vg^Cv錾	*/
static void lcdOut4( uint8_t d );
static void lcdOut8( uint8_t d );

/* obNCg					*/
static uint8_t backLight_status = OFF;

/*****************************************************************************
*								f[^o(4BIT)
* Fuint8_t d f[^(4BIT̂ݗLj
* ߒlFvoid
*****************************************************************************/
static void lcdOut4( uint8_t d )
{
	DATA_PORT = ( DATA_PORT & 0xf0 ) | ( d & 0x0f );

	E_ENABLE();
	_delay_us( E_WAIT_TIME );

	E_DISABLE();
	_delay_us( E_WAIT_TIME );
}

/*****************************************************************************
*								f[^o(8BIT)
* Fuint8_t d o̓f[^
* ߒlFvoid
* RSMݒ肵ĂĂяo
*****************************************************************************/
static void lcdOut8( uint8_t d )
{
	RW_WRITE();
	PORT_MODE_OUT();

	lcdOut4( d >> 4 );
	lcdOut4( d      );

	/* LCD̏҂		*/
#if USE_RW
	RW_READ();
	PORT_MODE_IN();					/* RW = 1 , ̓[h		*/
	RS_INSTRUCTIONCODE();			/* RS  = 0					*/
	_delay_us( RS_WAIT_TIME );

	uint8_t busy;
	do {
		/* 4rbgǍ	*/
		E_ENABLE();
		_delay_us( E_WAIT_TIME );
		busy = DATA_PIN;
		E_DISABLE();
		_delay_us( E_WAIT_TIME );

		/* 4rbgǍ	*/
		E_ENABLE();
		_delay_us( E_WAIT_TIME );
		E_DISABLE();
		_delay_us( E_WAIT_TIME );

	} while ( busy & 0x08 );		/* BusyȂ烋[vp		*/

#else
	_delay_ms( NORMAL_COMMAND_TIME );

#endif

}

/*****************************************************************************
*							LCDW[
* Fuint8_t sw ON / OFF  ̃obNCg
* ߒlFvoid
*****************************************************************************/
void lcdInit( uint8_t sw )
{
	/* e|[go͐ݒ			*/
	#if USE_BACKLIGHT
	BACKLIGHT_DDR |= _BV( BACKLIGHT_BIT );
	BACKLIGHT_PORT &= ~_BV( BACKLIGHT_BIT );
	#endif

	DATA_DDR |= 0x0f; 
	DATA_PORT &= ~0x0f;

	#if USE_POWER
	POWER_DDR |= _BV( POWER_BIT );
	#endif

	#if USE_RW
	RW_DDR  |=  _BV( RW_BIT );
	RW_PORT &= ~_BV( RW_BIT );
	#endif

	E_DDR  |= _BV( E_BIT );
	E_PORT &= ~_BV( E_BIT );

	RS_DDR  |=  _BV( RS_BIT );
	RS_PORT &= ~_BV( RS_BIT );

	/*@Zbg				*/
#if USE_POWER								/* dRg[L̂	*/
	POWER_PORT &= ~_BV( POWER_BIT );		/* dOFF/ONɂ胊Zbg	*/
	_delay_ms( 10 );
	POWER_PORT |= _BV( POWER_BIT );
	_delay_ms( 10 );
#endif

	/* e|[glo			*/
	E_DISABLE();
	#if USE_RW
	RW_WRITE();
	#endif
	RS_INSTRUCTIONCODE();

	/* 4bit[hJڃV[PX	*/
	_delay_ms( 50 );
	lcdOut4( 0x03 ); _delay_ms( 5   );		/* 8bit[hݒ				*/
	lcdOut4( 0x03 ); _delay_ms( 0.2 );		/* 8bit[hݒ				*/
	lcdOut4( 0x03 ); _delay_ms( 0.2 );		/* 8bit[hݒimj		*/
	lcdOut4( 0x02 ); 						/* 4bit[hݒimj		*/

	/* LCD				*/
	lcdOut8( 0x28 );						/* 4bitBus/2s\/8linemode	*/
	lcdOut8( 0x08 );						/* \OFF						*/

	lcdOut8( 0x01 );						/* ʃNA					*/
	#if ( !USE_RW )
	_delay_ms( CLS_COMMAND_TIME );
	#endif

	lcdOut8( 0x06 );						/* CNgL		*/
	lcdOut8( 0x0c );						/* \ON						*/

	/* obNCg			*/
	lcdBackLight( sw );
}

/*****************************************************************************
*								obNCgԎ擾
* Fvoid
* ߒlFuiknt8_t ON/OFF
*****************************************************************************/
uint8_t lcdBackLightStatus( void )
{
	return ( backLight_status );
}

/*****************************************************************************
*								obNCg
* Fuint8_t sw ON / OFF
* ߒlFvoid
*****************************************************************************/
void lcdBackLight( uint8_t sw )
{
	if ( sw == OFF ) {
	#if USE_BACKLIGHT
		BACKLIGHT_PORT &= ~_BV( BACKLIGHT_BIT );
	#endif
		backLight_status = OFF;
	} else {
	#if USE_BACKLIGHT
		BACKLIGHT_PORT |= _BV( BACKLIGHT_BIT );
	#endif
		backLight_status = ON;
	}
}

/*****************************************************************************
*								ʃNA
* Fvoid
* ߒlFvoid
*****************************************************************************/
void lcdCls( void )
{
	RS_INSTRUCTIONCODE();
	_delay_us( RS_WAIT_TIME );

	lcdOut8( 0x01 );					/* clear display	*/
#if ( !USE_RW )
	_delay_ms( CLS_COMMAND_TIME );
#endif

	lcdLocate( 0 ,0 );
}

/*****************************************************************************
*							J[\^CvύX
* FLCD_CURSOL_TYPE type J[\^Cv
*							 LCD_CURSOL_OFF      : J[\\
*							 LCD_CURCOL_BLINK    : ubN_
*							 LCD_CURSOL_UNDERBAR : A_[o[
* ߒlFvoid
*****************************************************************************/
void lcdCursol( LCD_CURSOL_TYPE type )
{
	RS_INSTRUCTIONCODE();
	_delay_us( RS_WAIT_TIME );
	lcdOut8( 0x0c | ( type & 0x03 ) );
}

/*****************************************************************************
*								J[\ړ
* Fuint8_t row		sԍ(0`)
*		uint8_t column	ԍ(0`)
* ߒlFvoid
*****************************************************************************/
void lcdLocate( uint8_t row ,uint8_t column )
{
	if ( row == 1 ) {
		column += 0x40;
	}

	RS_INSTRUCTIONCODE();
	_delay_us( RS_WAIT_TIME );
	lcdOut8( 0x80 | column );
}

/*****************************************************************************
*								Po
* Fchar c         R[h
* ߒlFvoid
*****************************************************************************/
void lcdPutc( char c )
{
	RS_DATACODE();
	_delay_us( RS_WAIT_TIME );
	lcdOut8( c );
}

/*****************************************************************************
*						RAM̈̕o
*	Fchar *s  
*	ߒlF
*****************************************************************************/
void lcdPuts( char *s )
{
	while ( *s ) {
		lcdPutc( *s++ );
	}
}

/*****************************************************************************
*						R[ḧ̕o
*	Fconst char *s 
*	ߒlFvoid
*
*	ex. lcdPuts_P( PSTR( "Test!!" ) );
*****************************************************************************/
void lcdPuts_P( const char *s ) 
{
	char c;
	while ( ( c = pgm_read_byte( s++ ) ) ) {
		lcdPutc( c );
	}
}
