/*###########################################################################
#                                                                           #
#                        USBd wb_[					            #
#                                                                           #
###########################################################################*/
#ifndef __PROJECT_H__
#define __PROJECT_H__

/* VXe萔`				*/
#define AVCC    5.020				/* AVCCdliVj					*/
#define IN_VREF 1.080				/* dliVj				*/

#define VBUS_A  5.090				/* USB-A : VBUSdl(V)				*/
#define VBUS_B  5.090				/* USB-B : VBUSdl(V)				*/

#define V_ADJ_A 4.6					/* USB-A:VgRd~␳{	*/
#define V_ADJ_B 5.0					/* USB-B:VgRd~␳{	*/

#define ADC_RESOLUTION 1024			/* ADC̕\							*/

#define SHUNT_R  0.010				/* VgRl()					*/
#define OPAMP_R1 2400.0				/* IyAv Rij					*/
#define OPAMP_RF 220000.0			/* IyAv RfijAҒR		*/

#define VBUS_R1  24000.0			/* VBUS Rl(+) 				*/
#define VBUS_R2  10000.0			/* VBUS Rl(GND) 			*/

/* ADCNbN萔`		*/
#define ADC_FDIV2   ( ( 0 << ADPS2 ) | ( 0 << ADPS1 ) | ( 1 << ADPS0 ) )
#define ADC_FDIV4   ( ( 0 << ADPS2 ) | ( 1 << ADPS1 ) | ( 0 << ADPS0 ) )
#define ADC_FDIV8   ( ( 0 << ADPS2 ) | ( 1 << ADPS1 ) | ( 1 << ADPS0 ) )
#define ADC_FDIV16  ( ( 1 << ADPS2 ) | ( 0 << ADPS1 ) | ( 0 << ADPS0 ) )
#define ADC_FDIV32  ( ( 1 << ADPS2 ) | ( 0 << ADPS1 ) | ( 1 << ADPS0 ) )
#define ADC_FDIV64  ( ( 1 << ADPS2 ) | ( 1 << ADPS1 ) | ( 0 << ADPS0 ) )
#define ADC_FDIV128 ( ( 1 << ADPS2 ) | ( 1 << ADPS1 ) | ( 1 << ADPS0 ) )

/* USB|[gԍ`(0`)		*/
#define USB_A 0
#define USB_B 1
#define USB_N 2						/* ̏2|[gŒ						*/

/* USBd[h`			*/
#define MODE_STANDBY  0				/* X^oC[h							*/
#define MODE_ENABLE   1				/* d									*/
#define MODE_OVERLOAD 2				/* ߓdɂVbg_E				*/

/* ADC`lԍ`		*/
#define ADC_VBUS_A PC0
#define ADC_GND_A  PC1
#define ADC_VBUS_B PC3
#define ADC_GND_B  PC2

/* et@CCN[h		*/
#include <stdio.h>
#include <string.h>

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/sleep.h>
#include <avr/eeprom.h>
#include <avr/wdt.h>
#include <avr/pgmspace.h>
#include <util/delay.h>

#include "myUTIL/SC1602/lcd.h"
#include "myUTIL/KEYS/keys.h"
#include "myUTIL/crc.h"
#include "myUTIL/cpu.h"

/* LED|[g`				*/
#define LED1_PIN PIND
#define LED1_BIT PD5

#define LED2_PIN PIND
#define LED2_BIT PD7

/* XCb`|[g`			*/
#define SW_PIN PINB
#define SW1_BIT PB6
#define SW2_BIT PB2

/* EGCg}N`			*/
#define WAIT_MS(t) { for ( uint16_t i = (uint16_t)(t) ;i ;i-- ) { _delay_ms( 1 ); wdt_reset(); } }

/* CPUX[vԒ萔`		*/
#define SLEEP_10MS ( (uint8_t)( 0.010 / ( 1.0 / ( F_CPU / 1024.0 ) ) ) )
#define SLEEP_20MS ( (uint8_t)( 0.020 / ( 1.0 / ( F_CPU / 1024.0 ) ) ) )
#define SLEEP_30MS ( (uint8_t)( 0.030 / ( 1.0 / ( F_CPU / 1024.0 ) ) ) )
#define SLEEP_40MS ( (uint8_t)( 0.040 / ( 1.0 / ( F_CPU / 1024.0 ) ) ) )
#define SLEEP_50MS ( (uint8_t)( 0.050 / ( 1.0 / ( F_CPU / 1024.0 ) ) ) )
#define SLEEP_60MS ( (uint8_t)( 0.060 / ( 1.0 / ( F_CPU / 1024.0 ) ) ) )
#define SLEEP_70MS ( (uint8_t)( 0.070 / ( 1.0 / ( F_CPU / 1024.0 ) ) ) )
#define SLEEP_80MS ( (uint8_t)( 0.080 / ( 1.0 / ( F_CPU / 1024.0 ) ) ) )
#define SLEEP_90MS ( (uint8_t)( 0.090 / ( 1.0 / ( F_CPU / 1024.0 ) ) ) )
#define SLEEP_100MS ( (uint8_t)( 0.100 / ( 1.0 / ( F_CPU / 1024.0 ) ) ) )
#define SLEEP_150MS ( (uint8_t)( 0.150 / ( 1.0 / ( F_CPU / 1024.0 ) ) ) )
#define SLEEP_200MS ( (uint8_t)( 0.200 / ( 1.0 / ( F_CPU / 1024.0 ) ) ) )
#define SLEEP_250MS ( (uint8_t)( 0.250 / ( 1.0 / ( F_CPU / 1024.0 ) ) ) )

/* LED Ԓ萔`				*/
#define LED_OFF 0
#define LED_ON 1

/* XCb`Ԓ萔`			*/
#define SW_OFF 0
#define SW_ON 1

/* VXeϐ\̒`		*/
typedef struct EEP_t {
	uint32_t avcc;								/* AVCC̎dl(V)			*/
	uint32_t vref;								/* dliVj		*/
	uint32_t usb_vbus[ USB_N ];					/* USB(VBUS-GND)dl		*/
	uint32_t vadj[ USB_N ];						/* VgR덷␳{		*/
	uint16_t usb_CurrentWarning[ USB_N ];		/* x\Jndl (mA)		*/
} EEP;

typedef struct SYSTEM_t {
	uint32_t OPAMP_offset[ USB_N ];				/* IyAvo̓ItZbg(uV)	*/
	uint16_t USB_voltage[ USB_N ];				/* USB VBUSdl(mV)			*/
	uint16_t USB_current[ USB_N ];				/* USB dl(mA)			*/
	uint8_t USB_voltage_vref[ USB_N ];			/* USB VBUSd胊t@Xd[h 1:1.1V 3:AVCC	*/
	uint8_t USB_current_vref[ USB_N ];			/* USB VBUSd胊t@Xd[h 1:1.1V 3:AVCC	*/
	uint8_t USB_mode[ USB_N ];					/* USB d[h				*/
	long vbus_offset[ USB_N ];					/* USB(VBUS-GND)dItZbg	*/
} SYSTEM;

/* O[oϐ`			*/
#ifdef __MAIN_C__
SYSTEM sys;
EEP eep;
#else
extern SYSTEM sys;
extern EEP eep;
#endif

/* ֐vg^Cv錾			*/

/* dcdc.c						*/
void dcdc_enable( uint8_t port );
void dcdc_disable( uint8_t port );
void dcdc_enable_all( void );
void dcdc_disable_all( void );
uint8_t dcdc_is_enable( uint8_t port );

/* switch_led.c					*/
uint8_t sw_status( uint8_t port );
void led_set_mode( uint8_t port ,uint8_t mode );
uint8_t led_get_mode( uint8_t port );
void led_all_off( void );
void led_all_on( void );

/* measurement.c				*/
void adc_init( void );
uint16_t adc_execution( uint8_t ch );
void adc_select_vref( uint8_t mode );
uint32_t adc_get_value( uint8_t ch );
uint32_t measurement_vbus_gnd( uint8_t port );
void measurement_usb_port( uint8_t port );
void measurement_offsets( void );
void wait_no_load( void );

/* round.c						*/
uint16_t shift_right( uint16_t val ,uint8_t k );
uint32_t shift_right32( uint32_t val ,uint8_t k );

/* system_setup.c				*/
void save_eep( void );
uint8_t load_eep( void );
void system_setup( void );

#endif /* __PROJECT_H__ */
