#define __SWITCH_C__
#include "project.h"

/* ef[^WX^`				*/
#define LED1_DDR  ( *(volatile uint8_t *)( &LED1_PIN + 0x01 ) )
#define LED1_PORT ( *(volatile uint8_t *)( &LED1_PIN + 0x02 ) )

#define LED2_DDR  ( *(volatile uint8_t *)( &LED2_PIN + 0x01 ) )
#define LED2_PORT ( *(volatile uint8_t *)( &LED2_PIN + 0x02 ) )

/* ef[^WX^`				*/
#define SW_DDR  ( *(volatile uint8_t *)( &SW_PIN + 0x01 ) )
#define SW_PORT ( *(volatile uint8_t *)( &SW_PIN + 0x02 ) )

/*****************************************************************************
*							XCb`Ԏ擾
* Fuint8_t port |[gԍ( USB_A / USB_B )
* ߒlFuint8_t      ԁi SW_ON / SW_OFF )
*****************************************************************************/
uint8_t sw_status( uint8_t port )
{
	uint8_t sw = OFF;

	if ( port == USB_A ) {
		if ( !( SW_PIN & _BV(SW1_BIT) ) ) {
			sw = SW_ON;
		}

	} else if ( port == USB_B ) {
		if ( !( SW_PIN & _BV(SW2_BIT) ) ) {
			sw = SW_ON;
		}
	}

	return ( sw );
}

/*****************************************************************************
*								kdcԐݒ
* Fuint8_t port |[gԍ( USB_A / USB_B )
*       uint8_t mode  LED_ON / LED_OFF 
* ߒlFvoid
*****************************************************************************/
void led_set_mode( uint8_t port ,uint8_t mode )
{
	uint8_t sw = 0;
	if ( port == USB_A ) {
		sw = _BV( PD5 );
	} else {
		sw = _BV( PD7 );
	}

	if ( mode == LED_ON ) {
		PORTD &= ~sw;
	} else {
		PORTD |= sw;
	}
}

/*****************************************************************************
*								kdcԎ擾
* Fuint8_t port |[gԍ( USB_A / USB_B )
* ߒlFuint8_t LED_ON / LED_OFF
*****************************************************************************/
uint8_t led_get_mode( uint8_t port )
{
	uint8_t sw = 0;
	if ( port == USB_A ) {
		sw = ( PORTD & _BV( PD5 ) ) ? LED_OFF : LED_ON;
	} else {
		sw = ( PORTD & _BV( PD7 ) ) ? LED_OFF : LED_ON;
	}
	return ( sw );
}

/*****************************************************************************
*								SLED
* Fvoid
* ߒlFvoid
*****************************************************************************/
void led_all_off( void )
{
	for ( uint8_t i = 0 ;i < USB_N ;i++ ) {
		led_set_mode( i ,LED_OFF );
	}
}

/*****************************************************************************
*								SLED_
* Fvoid
* ߒlFvoid
*****************************************************************************/
void led_all_on( void )
{
	for ( uint8_t i = 0 ;i < USB_N ;i++ ) {
		led_set_mode( i ,LED_ON );
	}
}
